| The Gaudi Framework v32r1 (f65d50dc)

Classes | Public Member Functions | Private Types | Private Member Functions | Private Attributes | List of all members
IncidentSvc Class Reference

Default implementation of the IIncidentSvc interface. More...

`#include <src/IncidentSvc/IncidentSvc.h>`

Inheritance diagram for IncidentSvc:
[legend]
Collaboration diagram for IncidentSvc:
[legend]

## Classes
struct | Listener

## Public Member Functions
StatusCode | initialize () override
StatusCode | finalize () override
void | addListener (IIncidentListener *lis, const std::string &type="", long priority=0, bool rethrow=false, bool singleShot=false) override
void | removeListener (IIncidentListener *l, const std::string &type="") override
void | fireIncident (const Incident &incident) override
void | fireIncident (std::unique_ptr< Incident > incident) override
void | getListeners (std::vector< IIncidentListener * > &lis, const std::string &type="") const override
| IncidentSvc (const std::string &name, ISvcLocator *svc)
| ~IncidentSvc () override
IIncidentSvc::IncidentPack | getIncidents (const EventContext *ctx) override
Public Member Functions inherited from extends< Service, IIncidentSvc >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
| Declare used tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Public Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const
| Backward compatibility function for getting the output level. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...

## Private Types
typedef std::list< Listener > | ListenerList
typedef GaudiUtils::HashMap< Gaudi::StringKey, std::unique_ptr< ListenerList > > | ListenerMap
typedef tbb::concurrent_queue< Incident * > | IncQueue_t

## Private Member Functions
ListenerMap::iterator | removeListenerFromList (ListenerMap::iterator, IIncidentListener *item, bool scheduleRemoval)
void | i_fireIncident (const Incident &incident, const std::string &type)
| Internal function to allow incidents listening to all events. More...

## Private Attributes
ListenerMap | m_listenerMap
| List of auditor names. More...
const std::string * | m_currentIncidentType = nullptr
| Incident being fired. More...
std::recursive_mutex | m_listenerMapMutex
| Mutex to synchronize access to m_listenerMap. More...
ChronoEntity | m_timer
| timer & it's lock More...
bool | m_timerLock = false
tbb::concurrent_unordered_map< EventContext, IncQueue_t, EventContextHash, EventContextHash > | m_firedIncidents

## Additional Inherited Members
Public Types inherited from extends< Service, IIncidentSvc >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
using | Factory = Gaudi::PluginService::Factory< IService *(const std::string &, ISvcLocator *)>
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | setUpMessaging () const
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, " unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Default implementation of the IIncidentSvc interface.

This implementation is thread-safe with the following features:

- Calls to fireIncident(), addListener() and removeListener() are synchronized across threads.
- Calls to IIncidentListener::handle() are serialized, i.e. at any time there is at most one incident handler being executed across all threads.

Definition at line 38 of file IncidentSvc.h.

## Member Typedef Documentation

## ◆ IncQueue_t

typedef tbb::concurrent_queue<Incident*> IncidentSvc::IncQueue_t
| private

Definition at line 102 of file IncidentSvc.h.

## ◆ ListenerList

typedef std::list<Listener> IncidentSvc::ListenerList
| private

Definition at line 54 of file IncidentSvc.h.

## ◆ ListenerMap

typedef GaudiUtils::HashMap<Gaudi::StringKey, std::unique_ptr<ListenerList> > IncidentSvc::ListenerMap
| private

Definition at line 55 of file IncidentSvc.h.

## Constructor & Destructor Documentation

## ◆ IncidentSvc()

IncidentSvc::IncidentSvc | ( | const std::string & | name,
|  | ISvcLocator * | svc
| ) |  |

Definition at line 49 of file IncidentSvc.cpp.

49 : base_class( name, svc ) {}
extends< Service, IIncidentSvc >::base_class
extends base_class
Typedef to this class.
Definition: extends.h:14
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:274

## ◆ ~IncidentSvc()

IncidentSvc::~IncidentSvc | ( |  | ) |
| override

Definition at line 51 of file IncidentSvc.cpp.

51 { std::unique_lock<std::recursive_mutex> lock( m_listenerMapMutex ); }
IncidentSvc::m_listenerMapMutex
std::recursive_mutex m_listenerMapMutex
Mutex to synchronize access to m_listenerMap.
Definition: IncidentSvc.h:94
std::lock
T lock(T... args)
std::unique_lock

## Member Function Documentation

## ◆ addListener()

void IncidentSvc::addListener | ( | IIncidentListener * | lis,
|  | const std::string & | type = `""`,
|  | long | priority = `0`,
|  | bool | rethrow = `false`,
|  | bool | singleShot = `false`
| ) |  |
| override

Definition at line 91 of file IncidentSvc.cpp.

92 {
93 static const std::string all{"ALL"};
94 std::unique_lock<std::recursive_mutex> lock( m_listenerMapMutex );
95
96 const std::string& ltype = ( !type.empty() ? type : all );
97
98 // find if the type already exists
99 auto itMap = m_listenerMap.find( ltype );
100 if ( itMap == m_listenerMap.end() ) {
101 // if not found, create and insert now a list of listeners
102 auto p = m_listenerMap.insert( {ltype, std::make_unique<ListenerList>()} );
103 if ( !p.second ) { /* OOPS */
104 }
105 itMap = p.first;
106 }
107 auto& llist = *itMap->second;
108 // add Listener ordered by priority -- higher priority first,
109 // and then add behind listeneres with the same priority
110 // -- so we skip over all items with higher or same priority
111 auto i = std::partition_point( std::begin( llist ), std::end( llist ),
112 [&]( const Listener& j ) { return j.priority >= prio; } );
113 // We insert before the current position
114 DEBMSG << "Adding [" << type << "] listener '" << getListenerName( lis ) << "' with priority " << prio << endmsg;
115 llist.emplace( i, lis, prio, rethrow, singleShot );
116 }
std::partition_point
T partition_point(T... args)
std::end
T end(T... args)
DEBMSG
#define DEBMSG
Definition: IncidentSvc.cpp:43
std::string
STL class.
GaudiUtils::Map::insert
std::pair< iterator, bool > insert(ValueType &&val)
Definition: Map.h:168
GaudiUtils::Map::end
iterator end()
Definition: Map.h:130
IncidentSvc::m_listenerMapMutex
std::recursive_mutex m_listenerMapMutex
Mutex to synchronize access to m_listenerMap.
Definition: IncidentSvc.h:94
gaudirun.type
type
Definition: gaudirun.py:142
GaudiUtils::Map::find
iterator find(const key_type &key)
Definition: Map.h:147
std::lock
T lock(T... args)
std::unique_lock
std::begin
T begin(T... args)
IncidentSvc::m_listenerMap
ListenerMap m_listenerMap
List of auditor names.
Definition: IncidentSvc.h:87
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ finalize()

StatusCode IncidentSvc::finalize | ( |  | ) |
| override

Definition at line 71 of file IncidentSvc.cpp.

71 {
72 DEBMSG << m_timer.outputUserTime( "Incident timing: Mean(+-rms)/Min/Max:%3%(+-%4%)/%6%/%7%[ms] ", System::milliSec )
73 << m_timer.outputUserTime( "Total:%2%[s]", System::Sec ) << endmsg;
74
75 {
76 // clear the local storage of allocated Incident objects.
77 std::unique_lock<std::recursive_mutex> lock( m_listenerMapMutex );
78 for ( auto& fi : m_firedIncidents ) {
79 std::for_each( fi.second.unsafe_begin(), fi.second.unsafe_end(), []( auto i ) { delete i; } );
80 fi.second.clear();
81 }
82 m_firedIncidents.clear();
83 }
84
85 // Finalize this specific service
86 return Service::finalize();
87 }
IncidentSvc::m_timer
ChronoEntity m_timer
timer & it's lock
Definition: IncidentSvc.h:97
Service::finalize
StatusCode finalize() override
Definition: Service.cpp:164
System::milliSec
Definition: Timing.h:57
DEBMSG
#define DEBMSG
Definition: IncidentSvc.cpp:43
System::Sec
Definition: Timing.h:57
IncidentSvc::m_listenerMapMutex
std::recursive_mutex m_listenerMapMutex
Mutex to synchronize access to m_listenerMap.
Definition: IncidentSvc.h:94
std::lock
T lock(T... args)
IncidentSvc::m_firedIncidents
tbb::concurrent_unordered_map< EventContext, IncQueue_t, EventContextHash, EventContextHash > m_firedIncidents
Definition: IncidentSvc.h:103
std::unique_lock
std::for_each
T for_each(T... args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
ChronoEntity::outputUserTime
std::string outputUserTime() const
print the chrono ;
Definition: ChronoEntity.cpp:82

## ◆ fireIncident() [1/2]

void IncidentSvc::fireIncident | ( | const Incident & | incident | ) |
| override

Definition at line 225 of file IncidentSvc.cpp.

225 {
226
227 Gaudi::Utils::LockedChrono timer( m_timer, m_timerLock );
228
229 // Call specific listeners
230 i_fireIncident( incident, incident.type() );
231 // Try listeners registered for ALL incidents
232 if ( incident.type() != "ALL" ) { // avoid double calls if somebody fires the incident "ALL"
233 i_fireIncident( incident, "ALL" );
234 }
235 }
IncidentSvc::m_timer
ChronoEntity m_timer
timer & it's lock
Definition: IncidentSvc.h:97
Incident::type
const std::string & type() const
Access to the incident type.
Definition: Incident.h:38
IncidentSvc::m_timerLock
bool m_timerLock
Definition: IncidentSvc.h:98
Gaudi::Utils::LockedChrono
Helper object, useful for measurement of CPU-performance of highly-recursive structures,...
Definition: LockedChrono.h:50
IncidentSvc::i_fireIncident
void i_fireIncident(const Incident &incident, const std::string &type)
Internal function to allow incidents listening to all events.
Definition: IncidentSvc.cpp:157

## ◆ fireIncident() [2/2]

void IncidentSvc::fireIncident | ( | std::unique_ptr< Incident > | incident | ) |
| override

Definition at line 237 of file IncidentSvc.cpp.

237 {
238
239 DEBMSG << "Async incident '" << incident->type() << "' fired on context " << incident->context() << endmsg;
240 auto ctx = incident->context();
241 auto res = m_firedIncidents.insert( std::make_pair( ctx, IncQueue_t() ) );
242 res.first->second.push( incident.release() );
243 }
Incident::type
const std::string & type() const
Access to the incident type.
Definition: Incident.h:38
DEBMSG
#define DEBMSG
Definition: IncidentSvc.cpp:43
Incident::context
EventContext context() const
Access to the EventContext of the source of the incident.
Definition: Incident.h:50
std::unique_ptr::release
T release(T... args)
std::make_pair
T make_pair(T... args)
IncidentSvc::IncQueue_t
tbb::concurrent_queue< Incident * > IncQueue_t
Definition: IncidentSvc.h:102
IncidentSvc::m_firedIncidents
tbb::concurrent_unordered_map< EventContext, IncQueue_t, EventContextHash, EventContextHash > m_firedIncidents
Definition: IncidentSvc.h:103
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ getIncidents()

IIncidentSvc::IncidentPack IncidentSvc::getIncidents | ( | const EventContext * | ctx | ) |
| override

Definition at line 263 of file IncidentSvc.cpp.

263 {
264 IIncidentSvc::IncidentPack p;
265 if ( ctx ) {
266 auto incs = m_firedIncidents.find( *ctx );
267 if ( incs != m_firedIncidents.end() ) {
268 Incident* inc( 0 );
269
270 DEBMSG << "Collecting listeners fired on context " << *ctx << endmsg;
271 while ( incs->second.try_pop( inc ) ) {
272 std::vector<IIncidentListener*> ls;
273 getListeners( ls, inc->type() );
274 p.incidents.emplace_back( std::move( inc ) );
275 p.listeners.emplace_back( std::move( ls ) );
276 }
277 }
278 }
279 return p;
280 }
DEBMSG
#define DEBMSG
Definition: IncidentSvc.cpp:43
IIncidentSvc::IncidentPack::incidents
std::vector< std::unique_ptr< Incident > > incidents
Definition: IIncidentSvc.h:51
IIncidentSvc::IncidentPack::listeners
std::vector< std::vector< IIncidentListener * > > listeners
Definition: IIncidentSvc.h:52
IIncidentSvc::IncidentPack
Definition: IIncidentSvc.h:49
std::move
T move(T... args)
IncidentSvc::getListeners
void getListeners(std::vector< IIncidentListener * > &lis, const std::string &type="") const override
Definition: IncidentSvc.cpp:246
IncidentSvc::m_firedIncidents
tbb::concurrent_unordered_map< EventContext, IncQueue_t, EventContextHash, EventContextHash > m_firedIncidents
Definition: IncidentSvc.h:103
std::vector
STL class.
Incident
Base class for all Incidents (computing events).
Definition: Incident.h:17
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192
std::vector::emplace_back
T emplace_back(T... args)

## ◆ getListeners()

void IncidentSvc::getListeners | ( | std::vector< IIncidentListener * > & | lis,
|  | const std::string & | type = `""`
| ) |  | const
| override

Definition at line 246 of file IncidentSvc.cpp.

246 {
247 static const std::string ALL{"ALL"};
248 std::unique_lock<std::recursive_mutex> lock( m_listenerMapMutex );
249
250 const std::string& ltype = ( !type.empty() ? type : ALL );
251
252 l.clear();
253 auto i = m_listenerMap.find( ltype );
254 if ( i != m_listenerMap.end() ) {
255 l.reserve( i->second->size() );
256 std::transform( std::begin( *i->second ), std::end( *i->second ), std::back_inserter( l ),
257 []( const Listener& j ) { return j.iListener; } );
258 }
259 }
GaudiKernel.Constants.ALL
int ALL
Definition: Constants.py:11
std::end
T end(T... args)
std::string
STL class.
GaudiUtils::Map::end
iterator end()
Definition: Map.h:130
IncidentSvc::m_listenerMapMutex
std::recursive_mutex m_listenerMapMutex
Mutex to synchronize access to m_listenerMap.
Definition: IncidentSvc.h:94
gaudirun.type
type
Definition: gaudirun.py:142
GaudiUtils::Map::find
iterator find(const key_type &key)
Definition: Map.h:147
std::lock
T lock(T... args)
gaudirun.l
dictionary l
Definition: gaudirun.py:521
std::unique_lock
std::begin
T begin(T... args)
std::back_inserter
T back_inserter(T... args)
std::transform
T transform(T... args)
IncidentSvc::m_listenerMap
ListenerMap m_listenerMap
List of auditor names.
Definition: IncidentSvc.h:87

## ◆ i_fireIncident()

void IncidentSvc::i_fireIncident | ( | const Incident & | incident,
|  | const std::string & | type
| ) |  |
| private

Internal function to allow incidents listening to all events.

Definition at line 157 of file IncidentSvc.cpp.

157 {
158
159 std::unique_lock<std::recursive_mutex> lock( m_listenerMapMutex );
160
161 // Wouldn't it be better to write a small 'ReturnCode' service which
162 // looks for these 'special' incidents and does whatever needs to
163 // be done instead of making a special case here?
164
165 // Special case: FailInputFile incident must set the application return code
166 if ( incident.type() == IncidentType::FailInputFile || incident.type() == IncidentType::CorruptedInputFile ) {
167 auto appmgr = serviceLocator()->as<IProperty>();
168 Gaudi::setAppReturnCode( appmgr, incident.type() == IncidentType::FailInputFile
169 ? Gaudi::ReturnCode::FailInput
170 : Gaudi::ReturnCode::CorruptedInput )
171 .ignore();
172 }
173
174 auto ilisteners = m_listenerMap.find( listenerType );
175 if ( m_listenerMap.end() == ilisteners ) return;
176
177 // setting this pointer will avoid that a call to removeListener() during
178 // the loop triggers a segfault
179 m_currentIncidentType = &incident.type();
180
181 bool firedSingleShot = false;
182
183 auto& listeners = *ilisteners->second;
184
185 for ( auto& listener : listeners ) {
186
187 VERMSG << "Calling '" << getListenerName( listener.iListener ) << "' for incident [" << incident.type() << "]"
188 << endmsg;
189
190 // handle exceptions if they occur
191 try {
192 listener.iListener->handle( incident );
193 } catch ( const GaudiException& exc ) {
194 error() << "Exception with tag=" << exc.tag()
195 << " is caught"
196 " handling incident "
197 << *m_currentIncidentType << endmsg;
198 error() << exc << endmsg;
199 if ( listener.rethrow ) { throw exc; }
200 } catch ( const std::exception& exc ) {
201 error() << "Standard std::exception is caught"
202 " handling incident "
203 << *m_currentIncidentType << endmsg;
204 error() << exc.what() << endmsg;
205 if ( listener.rethrow ) { throw exc; }
206 } catch ( ... ) {
207 error() << "UNKNOWN Exception is caught"
208 " handling incident "
209 << *m_currentIncidentType << endmsg;
210 if ( listener.rethrow ) { throw; }
211 }
212 // check wheter one of the listeners is singleShot
213 firedSingleShot |= listener.singleShot;
214 }
215 if ( firedSingleShot ) {
216 // remove all the singleshot listeners that got there shot...
217 listeners.erase( std::remove_if( std::begin( listeners ), std::end( listeners ), isSingleShot ),
218 std::end( listeners ) );
219 if ( listeners.empty() ) m_listenerMap.erase( ilisteners );
220 }
221
222 m_currentIncidentType = nullptr;
223 }
Service::serviceLocator
SmartIF< ISvcLocator > & serviceLocator() const override
Retrieve pointer to service locator.
Definition: Service.cpp:277
GaudiException
Define general base for Gaudi exception.
Definition: GaudiException.h:21
Incident::type
const std::string & type() const
Access to the incident type.
Definition: Incident.h:38
GaudiException::tag
virtual const std::string & tag() const
name tag for the exception, or exception type
Definition: GaudiException.h:67
std::end
T end(T... args)
ISvcLocator::as
SmartIF< IFace > as()
Definition: ISvcLocator.h:103
std::remove_if
T remove_if(T... args)
Gaudi::ReturnCode::CorruptedInput
constexpr int CorruptedInput
Definition: AppReturnCode.h:28
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:98
GaudiUtils::Map::end
iterator end()
Definition: Map.h:130
IncidentSvc::m_listenerMapMutex
std::recursive_mutex m_listenerMapMutex
Mutex to synchronize access to m_listenerMap.
Definition: IncidentSvc.h:94
std::exception::what
T what(T... args)
Gaudi::ReturnCode::FailInput
constexpr int FailInput
Definition: AppReturnCode.h:23
GaudiUtils::Map::find
iterator find(const key_type &key)
Definition: Map.h:147
std::lock
T lock(T... args)
IncidentSvc::m_currentIncidentType
const std::string * m_currentIncidentType
Incident being fired.
Definition: IncidentSvc.h:91
std::exception
STL class.
Gaudi::setAppReturnCode
StatusCode setAppReturnCode(SmartIF< IProperty > &appmgr, int value, bool force=false)
Set the application return code.
Definition: AppReturnCode.h:49
std::unique_lock
GaudiUtils::Map::erase
iterator erase(const_iterator pos)
Definition: Map.h:182
VERMSG
#define VERMSG
Definition: IncidentSvc.cpp:44
std::begin
T begin(T... args)
IncidentSvc::m_listenerMap
ListenerMap m_listenerMap
List of auditor names.
Definition: IncidentSvc.h:87
IProperty
The IProperty is the basic interface for all components which have properties that can be set or get.
Definition: IProperty.h:20
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ initialize()

StatusCode IncidentSvc::initialize | ( |  | ) |
| override

Definition at line 55 of file IncidentSvc.cpp.

55 {
56 // initialize the Service Base class
57 StatusCode sc = Service::initialize();
58 if ( sc.isFailure() ) return sc;
59
60 m_currentIncidentType = nullptr;
61
62 // set my own (IncidentSvc) properties via the jobOptionService
63 sc = setProperties();
64 if ( UNLIKELY( sc.isFailure() ) ) {
65 error() << "Could not set my properties" << endmsg;
66 return sc;
67 }
68 return sc;
69 }
UNLIKELY
#define UNLIKELY(x)
Definition: Kernel.h:96
Service::initialize
StatusCode initialize() override
Definition: Service.cpp:60
CommonMessagingBase::error
MsgStream & error() const
shortcut for the method msgStream(MSG::ERROR)
Definition: CommonMessaging.h:98
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
IncidentSvc::m_currentIncidentType
const std::string * m_currentIncidentType
Incident being fired.
Definition: IncidentSvc.h:91
Service::setProperties
StatusCode setProperties()
Method for setting declared properties to the values specified for the job.
Definition: Service.cpp:280
StatusCode::isFailure
bool isFailure() const
Definition: StatusCode.h:130
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ removeListener()

void IncidentSvc::removeListener | ( | IIncidentListener * | l,
|  | const std::string & | type = `""`
| ) |  |
| override

Definition at line 137 of file IncidentSvc.cpp.

137 {
138 std::unique_lock<std::recursive_mutex> lock( m_listenerMapMutex );
139
140 bool scheduleForRemoval = ( m_currentIncidentType && type == *m_currentIncidentType );
141 if ( type.empty() ) {
142 auto i = std::begin( m_listenerMap );
143 while ( i != std::end( m_listenerMap ) ) { i = removeListenerFromList( i, lis, scheduleForRemoval ); }
144 } else {
145 auto i = m_listenerMap.find( type );
146 if ( i != m_listenerMap.end() ) removeListenerFromList( i, lis, scheduleForRemoval );
147 }
148 }
IncidentSvc::removeListenerFromList
ListenerMap::iterator removeListenerFromList(ListenerMap::iterator, IIncidentListener *item, bool scheduleRemoval)
Definition: IncidentSvc.cpp:119
std::end
T end(T... args)
GaudiUtils::Map::end
iterator end()
Definition: Map.h:130
IncidentSvc::m_listenerMapMutex
std::recursive_mutex m_listenerMapMutex
Mutex to synchronize access to m_listenerMap.
Definition: IncidentSvc.h:94
gaudirun.type
type
Definition: gaudirun.py:142
GaudiUtils::Map::find
iterator find(const key_type &key)
Definition: Map.h:147
std::lock
T lock(T... args)
IncidentSvc::m_currentIncidentType
const std::string * m_currentIncidentType
Incident being fired.
Definition: IncidentSvc.h:91
std::unique_lock
std::begin
T begin(T... args)
IncidentSvc::m_listenerMap
ListenerMap m_listenerMap
List of auditor names.
Definition: IncidentSvc.h:87

## ◆ removeListenerFromList()

IncidentSvc::ListenerMap::iterator IncidentSvc::removeListenerFromList | ( | ListenerMap::iterator | i,
|  | IIncidentListener * | item,
|  | bool | scheduleRemoval
| ) |  |
| private

Definition at line 119 of file IncidentSvc.cpp.

119 {
120 auto match = [&]( ListenerList::const_reference j ) { return !item || item == j.iListener; };
121
122 auto& c = *( i->second );
123 if ( !scheduleRemoval ) {
124 ON_DEBUG std::for_each( std::begin( c ), std::end( c ), [&]( ListenerList::const_reference j ) {
125 if ( match( j ) )
126 debug() << "Removing [" << i->first << "] listener '" << getListenerName( j.iListener ) << "'" << endmsg;
127 } );
128 c.erase( std::remove_if( std::begin( c ), std::end( c ), match ), std::end( c ) );
129 } else {
130 std::for_each( std::begin( c ), std::end( c ), [&]( Listener& i ) {
131 if ( match( i ) ) i.singleShot = true; // will trigger removal as soon as it is safe
132 } );
133 }
134 return c.empty() ? m_listenerMap.erase( i ) : std::next( i );
135 }
gaudirun.c
c
Definition: gaudirun.py:487
ON_DEBUG
#define ON_DEBUG
Definition: IncidentSvc.cpp:40
std::end
T end(T... args)
std::remove_if
T remove_if(T... args)
std::next
T next(T... args)
CommonMessagingBase::debug
MsgStream & debug() const
shortcut for the method msgStream(MSG::DEBUG)
Definition: CommonMessaging.h:107
GaudiUtils::Map::erase
iterator erase(const_iterator pos)
Definition: Map.h:182
std::begin
T begin(T... args)
IncidentSvc::m_listenerMap
ListenerMap m_listenerMap
List of auditor names.
Definition: IncidentSvc.h:87
std::for_each
T for_each(T... args)
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## Member Data Documentation

## ◆ m_currentIncidentType

const std::string* IncidentSvc::m_currentIncidentType = nullptr
| private

Incident being fired.

It is used to know if we can safely remove a listener or we have to schedule its removal for later.

Definition at line 91 of file IncidentSvc.h.

## ◆ m_firedIncidents

tbb::concurrent_unordered_map<EventContext, IncQueue_t, EventContextHash, EventContextHash> IncidentSvc::m_firedIncidents
| private

Definition at line 103 of file IncidentSvc.h.

## ◆ m_listenerMap

ListenerMap IncidentSvc::m_listenerMap
| private

List of auditor names.

Definition at line 87 of file IncidentSvc.h.

## ◆ m_listenerMapMutex

std::recursive_mutex IncidentSvc::m_listenerMapMutex
| mutable private

Mutex to synchronize access to m_listenerMap.

Definition at line 94 of file IncidentSvc.h.

## ◆ m_timer

ChronoEntity IncidentSvc::m_timer
| mutable private

timer & it's lock

Definition at line 97 of file IncidentSvc.h.

## ◆ m_timerLock

bool IncidentSvc::m_timerLock = false
| mutable private

Definition at line 98 of file IncidentSvc.h.

The documentation for this class was generated from the following files:

- GaudiCoreSvc/src/IncidentSvc/IncidentSvc.h
- GaudiCoreSvc/src/IncidentSvc/IncidentSvc.cpp